"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const util_1 = require("../util");
exports.default = {
    tagName: 'aside',
    getCategories(element) {
        return ['flow content', 'sectioning content', 'palpable content'];
    },
    validateContext(element) {
        const result = [];
        return result;
    },
    validateContent(element) {
        const result = [];
        const { children } = element;
        result.push(...(0, util_1.validateCategory)('flow content', children));
        (0, util_1.walkDescendants)(element, descendant => {
            if ((0, util_1.isTag)('main', descendant)) {
                result.push({
                    expect: 'with no main element descendants',
                    got: (0, util_1.getNodeInfo)(descendant),
                    target: descendant
                });
            }
        });
        return result;
    }
};
//# sourceMappingURL=aside.js.map