"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const util_1 = require("../util");
exports.default = {
    tagName: 'body',
    getCategories(element) {
        return ['sectioning root'];
    },
    validateContext(element) {
        const result = [];
        if (element.parentElement
            && ((0, util_1.isNotTag)('html', element.parentElement)
                || element.parentElement.children.filter(node => node.nodeType === 1).indexOf(element) !== 1)) {
            result.push({
                expect: 'as the second element in an html element',
                target: element
            });
        }
        return result;
    },
    validateContent(element) {
        const result = [];
        const { children } = element;
        result.push(...(0, util_1.validateCategory)('flow content', children));
        return result;
    }
};
//# sourceMappingURL=body.js.map