"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const util_1 = require("../util");
exports.default = {
    tagName: 'dl',
    getCategories(element) {
        const categories = ['flow content'];
        function startsNameValueGroup(child, index, children) {
            return (0, util_1.isTag)('dt', child)
                && children.slice(index + 1).some((0, util_1.isTag)('dd'));
        }
        if (element.children.some(startsNameValueGroup)) {
            categories.push('palpable content');
        }
        return categories;
    },
    validateContext(element) {
        const result = [];
        return result;
    },
    validateContent(element) {
        const result = [];
        const { children } = element;
        const childrenDtDd = children.filter(child => {
            if ((0, util_1.isTag)('dt|dd', child)) {
                return true;
            }
            if ((0, util_1.isNotCategory)('script-supporting element', child)) {
                result.push({
                    expect: 'dt, dd or script-supporting element',
                    got: (0, util_1.getNodeInfo)(child),
                    target: child
                });
            }
            return false;
        });
        const childrenDtDdTags = childrenDtDd.map(child => child.tagName).join(',');
        if (childrenDtDdTags && !/^((DT,)+(DD(,|$))+)*$/.test(childrenDtDdTags)) {
            result.push({
                expect: 'zero or more groups each consisting of one or more dt elements '
                    + 'followed by one or more dd elements',
                got: childrenDtDdTags,
                target: element
            });
        }
        return result;
    }
};
//# sourceMappingURL=dl.js.map