"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const util_1 = require("../util");
exports.default = {
    tagName: 'figure',
    getCategories(element) {
        return ['flow content', 'sectioning root', 'palpable content'];
    },
    validateContext(element) {
        const result = [];
        return result;
    },
    validateContent(element) {
        const result = [];
        const { children } = element;
        const figcaptionChildren = children.filter((0, util_1.isTag)('figcaption'));
        if (figcaptionChildren.length > 1) {
            result.push({
                expect: 'at most one figcaption element',
                got: `${figcaptionChildren.length} figcaption elements`,
                target: element
            });
        }
        figcaptionChildren.forEach(figcaptionChild => {
            if (figcaptionChild !== element.firstElementChild
                && figcaptionChild !== element.lastElementChild) {
                result.push({
                    expect: 'figcaption element to be the first or last child',
                    target: figcaptionChild
                });
            }
        });
        result.push(...(0, util_1.validateCategory)('flow content', children.filter((0, util_1.isNotTag)('figcaption'))));
        return result;
    }
};
//# sourceMappingURL=figure.js.map