"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const util_1 = require("../util");
exports.default = {
    tagName: 'head',
    getCategories(element) {
        return [];
    },
    validateContext(element) {
        const result = [];
        if (element.parentElement
            && ((0, util_1.isNotTag)('html', element.parentElement)
                || element.parentElement.children.filter(node => node.nodeType === 1).indexOf(element) !== 0)) {
            result.push({
                expect: 'as the first element in an html element',
                target: element
            });
        }
        return result;
    },
    validateContent(element) {
        const result = [];
        const { children } = element;
        result.push(...(0, util_1.validateCategory)('metadata content', children));
        if (children.filter((0, util_1.isTag)('title')).length > 1) {
            result.push({
                expect: 'no more than one title element',
                target: element
            });
        }
        if (children.filter((0, util_1.isTag)('base')).length > 1) {
            result.push({
                expect: 'no more than one base element',
                target: element
            });
        }
        return result;
    }
};
//# sourceMappingURL=head.js.map