"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const util_1 = require("../util");
exports.default = {
    tagName: 'meta',
    getCategories(element) {
        return ['metadata content'];
    },
    validateContext(element) {
        const result = [];
        if (element.hasAttribute('charset')
            || element.getAttribute('http-equiv') === 'content-type') {
            if (element.parentElement
                && (0, util_1.isNotTag)('head', element.parentElement)) {
                result.push({
                    expect: 'in a head element',
                    got: (0, util_1.getNodeInfo)(element.parentElement),
                    target: element
                });
            }
        }
        if (element.hasAttribute('http-equiv')
            && element.getAttribute('http-equiv') !== 'content-type') {
            if (element.parentElement
                && (0, util_1.isNotTag)('head', element.parentElement)
                && !((0, util_1.isTag)('noscript', element.parentElement)
                    && (0, util_1.isTag)('head', element.parentElement.parentElement))) {
                result.push({
                    expect: 'in a head element or in a noscript element that is a child of a head element',
                    target: element
                });
            }
        }
        return result;
    },
    validateContent(element) {
        const result = [];
        if (element.children.some(node => node.nodeType === 1)) {
            result.push({ expect: 'empty' });
        }
        return result;
    }
};
//# sourceMappingURL=meta.js.map