"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const util_1 = require("../util");
exports.default = {
    tagName: 'optgroup',
    getCategories(element) {
        return [];
    },
    validateContext(element) {
        const result = [];
        if (element.parentElement
            && (0, util_1.isNotTag)('select', element.parentElement)) {
            result.push({
                expect: 'as a child of an select element',
                got: (0, util_1.getNodeInfo)(element.parentElement),
                target: element
            });
        }
        return result;
    },
    validateContent(element) {
        const result = [];
        result.push(...(0, util_1.validateChildrenSequence)({
            desc: 'zero or more option and script-supporting elements',
            sequence: [['option|category:script-supporting element', '*']]
        }, element));
        return result;
    }
};
//# sourceMappingURL=optgroup.js.map