"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const util_1 = require("../util");
exports.default = {
    tagName: 'source',
    getCategories(element) {
        return [];
    },
    validateContext(element) {
        const result = [];
        if (element.parentElement) {
            if ((0, util_1.isNot)('media element', element.parentElement)) {
                result.push({
                    expect: 'as a child of a media element',
                    got: (0, util_1.getNodeInfo)(element.parentElement),
                    target: element
                });
            }
            for (let prev = element; (prev = prev.previousElementSibling);) {
                if ((0, util_1.isTag)('track', prev)
                    || (0, util_1.isCategory)('flow content', prev)) {
                    result.push({
                        expect: 'before any flow content or track elements',
                        target: element
                    });
                }
            }
        }
        return result;
    },
    validateContent(element) {
        const result = [];
        if (element.childNodes.length) {
            result.push({ expect: 'empty' });
        }
        return result;
    }
};
//# sourceMappingURL=source.js.map